
include    \masm32\include\masm32rt.inc
include    \masm32\include\ntdll.inc
includelib \masm32\lib\ntdll.lib

.const
Off4    dd 4294967295
TwoP29  dd 536870912

.data?
idh IMAGE_DOS_HEADER       <?>
inh IMAGE_NT_HEADERS       <?>
ish IMAGE_SECTION_HEADER   <>
PI  PROCESS_INFORMATION    <?>
SUI STARTUPINFO            <?>
cTXT CONTEXT               <?>

.data
Map0      equ PAGE_NOACCESS           ;1
Map1      equ PAGE_EXECUTE            ;10h
Map2      equ PAGE_READONLY           ;2
Map3      equ PAGE_EXECUTE_READ       ;20h
Map4      equ PAGE_READWRITE          ;4
Map5      equ PAGE_EXECUTE_READWRITE  ;40h
Map6      equ Map4                    ;4
Map7      equ Map5                    ;40h
Map       dd Map0,Map1,Map2,Map3,Map4,Map5,Map6,Map7
lpfname   db "c:\windows\system32\calc.exe",0
ComSpec   db "c:\windows\system32\cmd.exe",0
Buf       db 256 dup (0)
lpEXE     dd 0
lpLen     dd 0
ImageBase dd 0
xRet      dd 0
lOffset   dd 0
I         dd 0

.code
GLE PROC ERR:DWORD,Tit:DWORD
    .If ERR && Tit
        invoke GetLastError
        invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM+FORMAT_MESSAGE_MAX_WIDTH_MASK,
                             NULL,eax,NULL,offset Buf,SIZEOF Buf,NULL
        invoke MessageBox,NULL,offset Buf,Tit,MB_OK
        invoke CloseHandle,PI.hThread
        invoke CloseHandle,PI.hProcess
        invoke GlobalFree,lpEXE
    .ElseIf !ERR && Tit
        invoke MessageBox,NULL,Tit,chr$("Errors"),MB_OK
    .Else
        invoke CloseHandle,PI.hThread
        invoke CloseHandle,PI.hProcess
        invoke GlobalFree,lpEXE
    .EndIf
    exit
GLE ENDP

start:
Main Proc uses ebx;esi;edi
    invoke read_disk_file,offset lpfname,offset lpEXE,offset lpLen
    invoke RtlMoveMemory,offset idh,lpEXE,sizeof idh
    .If idh.e_magic != IMAGE_DOS_SIGNATURE
       invoke GLE,0,chr$("MZ Not Found!")
    .EndIf
    mov eax,lpEXE
    add eax,idh.e_lfanew
    invoke RtlMoveMemory,offset inh,eax,sizeof inh
    .If inh.Signature != IMAGE_NT_SIGNATURE
       invoke GLE,0,chr$("PE Not Found!")
    .EndIf
    mov SUI.cb,sizeof SUI
    invoke CreateProcess,NULL,offset ComSpec,NULL,NULL,FALSE,CREATE_SUSPENDED,
                         NULL,NULL,offset SUI,offset PI
    .If !eax
        invoke GLE,1,chr$("CreateProcess Error")
    .EndIf
    mov cTXT.ContextFlags,CONTEXT_INTEGER
    invoke GetThreadContext,PI.hThread,offset cTXT
    .If !eax
        invoke GLE,1,chr$("GetThreadContext Error")
    .Endif
    mov eax,cTXT.regEbx
    add eax,8
    invoke ReadProcessMemory,PI.hProcess,eax,offset xRet,4,NULL
    .If !xRet
        invoke GLE,1,chr$("ReadProcessMemory Error")
    .Endif
    invoke ZwUnmapViewOfSection,PI.hProcess,xRet
    .If eax
        invoke GLE,1,chr$("ZwUnmapViewOfSection Error")
    .Endif
    invoke VirtualAllocEx,PI.hProcess,inh.OptionalHeader.ImageBase,
                          inh.OptionalHeader.SizeOfImage,MEM_RESERVE Or MEM_COMMIT,PAGE_READWRITE
    .If !eax
        invoke GLE,1,chr$("VirtualAllocEx Error")
    .Endif
    mov ImageBase,eax
    invoke WriteProcessMemory,PI.hProcess,eax,lpEXE,inh.OptionalHeader.SizeOfHeaders,NULL
    .If !eax
        invoke GLE,1,chr$("WriteProcessMemory A")
    .Endif
    mov eax,idh.e_lfanew
    add eax,sizeof inh
    mov lOffset,eax
    movzx ebx,inh.FileHeader.NumberOfSections
    .While I < ebx
        mov eax,I
        imul eax,sizeof ish
        add eax,lOffset
        add eax,lpEXE
        invoke RtlMoveMemory,offset ish,eax,sizeof ish
        mov edi,ImageBase
        add edi,ish.VirtualAddress
        mov esi,lpEXE
        add esi,ish.PointerToRawData
        invoke WriteProcessMemory,PI.hProcess,edi,esi,ish.SizeOfRawData,NULL
        .If !eax
            invoke GLE,1,chr$("WriteProcessMemory B")
        .Endif
        mov eax,ish.Characteristics
        .If eax < 0
            add eax,Off4
        .EndIf
        mov ecx,TwoP29
        mov edx,0
        idiv ecx
        mov esi,offset Map
        mov esi,[esi+eax*4]
        invoke VirtualProtectEx,PI.hProcess,edi,ish.Misc.VirtualSize,esi,offset xRet
        .If !eax
            invoke GLE,1,chr$("VirtualProtectEx Error")
        .Endif
        inc I
    .EndW
    mov edi,cTXT.regEbx
    add edi,8
    invoke WriteProcessMemory,PI.hProcess,edi,ImageBase,4,NULL ;This is The Error Line
    .If !eax
        invoke GLE,1,chr$("WriteProcessMemory C")
    .Endif
    mov eax,ImageBase
    add eax,inh.OptionalHeader.AddressOfEntryPoint
    mov cTXT.regEax,eax
    invoke SetThreadContext,PI.hThread,offset cTXT
    invoke ResumeThread,PI.hThread
    invoke GLE,0,0
Main endp
END start